SoGroup Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoGroup Class Reference
Node Classes

The SoGroup class is a node which managed other node instances.The internal scene data structures in Coin are managed as directed graphs. The graphs are built by setting up a hierarchy through the use of group nodes (either of this type, or from subclasses like SoSeparator) which is then traversed when applying actions (like SoGLRenderAction) to it. More...

`#include <Inventor/nodes/SoGroup.h>`

Inheritance diagram for SoGroup:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | addChild (SoNode *node)
virtual void | insertChild (SoNode *child, int newchildindex)
virtual SoNode * | getChild (int index) const
virtual int | findChild (const SoNode *node) const
virtual int | getNumChildren (void) const
virtual void | removeChild (int childindex)
virtual void | removeChild (SoNode *child)
virtual void | removeAllChildren (void)
virtual void | replaceChild (int index, SoNode *newchild)
virtual void | replaceChild (SoNode *oldchild, SoNode *newchild)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoGroup ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | readChildren (SoInput *in)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SoChildList * | children
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoGroup class is a node which managed other node instances.

The internal scene data structures in Coin are managed as directed graphs. The graphs are built by setting up a hierarchy through the use of group nodes (either of this type, or from subclasses like SoSeparator) which is then traversed when applying actions (like SoGLRenderAction) to it.

SoGroup, SoSeparator, and other classes derived from SoGroup, are the "tools" the application programmer uses when making the layout of the scene graph.

An often asked question about SoGroup nodes is: "Why is there no SoGroup::getParent() method?" The answer to this is that nodes in the scene graph can have multiple parents, so a simple getParent() method wouldn't work. If you have a node pointer (or other node identification) of a node that you want to remove from the scene graph, what you need to do is to use an SoSearchAction to find all paths down to the node, and then invoke SoGroup::removeChild() from all found parents of the node.

The function would look something like this:

void getParents(SoNode * node, SoNode * root, SoPathList & parents)
{
SoSearchAction sa;
sa.setNode(node);
sa.setInterest(SoSearchAction::ALL);
sa.apply(root);
parents = sa.getPaths();
}

Or if you know that your node of interest has only a single parent:

SoGroup * getParent(SoNode * node, SoNode * root)
{
SoSearchAction sa;
sa.setNode(node);
sa.setInterest(SoSearchAction::FIRST);
sa.apply(root);
SoPath * p = sa.getPath();
assert(p && "not found");
if (p->getLength() < 2) { return NULL; } // no parent
return (SoGroup *)p->getNodeFromTail(1);
}

An important note about a potential problem using SoGroup nodes which it is not common to stumble on, but which makes hard to find bugs when one does: you should not change the scene graph layout during any action traversal, as that is not allowed by the internal Coin code. I.e. do not use addChild(), removeChild(), insertChild() or replaceChild() from any callback that is triggered directly or indirectly from an action traversal. The most common way of getting hit by this error, would be something like the following (simplified) example:

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/manips/SoPointLightManip.h>
#include <Inventor/events/SoMouseButtonEvent.h>
SoPointLightManip * global_pointlightmanip;
SoSeparator * global_root;
// Remove pointlight when clicking right mouse button.
static void
mySelectionC(void * ud, SoEventCallback * n)
{
const SoMouseButtonEvent * mbe = (SoMouseButtonEvent*) n->getEvent();
if ((mbe->getButton() == SoMouseButtonEvent::BUTTON2) &&
(mbe->getState() == SoButtonEvent::DOWN)) {
if (global_pointlightmanip) {
global_root->removeChild(global_pointlightmanip);
global_pointlightmanip = NULL;
}
}
}
int
main(int argc, char ** argv)
{
QWidget * window = SoQt::init(argv[0]);
global_root = new SoSeparator;
global_root->ref();
SoEventCallback * ecb = new SoEventCallback;
ecb->addEventCallback(SoMouseButtonEvent::getClassTypeId(), mySelectionC, 0);
global_root->addChild(ecb);
global_root->addChild(new SoCone);
global_pointlightmanip = new SoPointLightManip;
global_root->addChild(global_pointlightmanip);
SoQtExaminerViewer * viewer = new SoQtExaminerViewer(window);
viewer->setSceneGraph(global_root);
viewer->show();
SoQt::show(window);
SoQt::mainLoop();
global_root->unref();
delete viewer;
return 0;
}

What happens in the above case is this: when clicking with the right mouse button, the SoQtExaminerViewer converts the Qt event to a Coin event, which is sent down the scene graph with an SoHandleEventAction. The action traversal reaches the "global_root" SoSeparator node, where it sees that it should further traverse 3 child nodes (first the SoEventCallback, then the SoCone, then the SoPointLightManip). When it then traverses the SoEventCallback, the mySelectionC() callback will be invoked, which removes the last child. But the SoHandleEventAction will still continue it's traversal as if the global_root node has 3 children – and the code will crash.

(This exact example would perhaps be straight-forward to handle internally in Coin, but there are other ways to change the scene graph layout that are very difficult to handle properly. So in general, changing layout during action traversal is not allowed.)

What to do in these cases is to change the code inside the callback to not do any operations that immediately changes the layout of the scene graph, but to delay it for after the traversal is done. This can e.g. be done by using a Coin sensor.

FILE FORMAT/DEFAULTS:

Group {
}

## Constructor & Destructor Documentation

SoGroup::SoGroup | ( | void |  | ) |

Default constructor.

SoGroup::SoGroup | ( | int | nchildren | ) |

Constructor.

The argument should be the approximate number of children which is expected to be inserted below this node. The number need not be exact, as it is only used as a hint for better memory resource allocation.

SoGroup::~SoGroup | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

SoType SoGroup::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Implements SoBase.

Reimplemented in SoExtSelection, SoVRMLSwitch, SoSelection, SoWWWAnchor, SoVRMLAnchor, SoGeoSeparator, SoSwitch, SoShadowGroup, SoVRMLCollision, SoVRMLGroup, SoVRMLLOD, SoLocateHighlight, SoSeparator, SoVRMLBillboard, SoVRMLParent, SoBlinker, SoLOD, SoArray, SoLevelOfDetail, SoVRMLTransform, SoMultipleCopy, SoPathSwitch, SoAnnotation, and SoTransformSeparator.

const SoFieldData * SoGroup::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

Reimplemented in SoExtSelection, SoVRMLSwitch, SoSelection, SoWWWAnchor, SoVRMLAnchor, SoGeoSeparator, SoSwitch, SoShadowGroup, SoVRMLCollision, SoVRMLGroup, SoVRMLLOD, SoLocateHighlight, SoSeparator, SoVRMLBillboard, SoVRMLParent, SoBlinker, SoLOD, SoArray, SoLevelOfDetail, SoVRMLTransform, SoMultipleCopy, SoPathSwitch, SoAnnotation, and SoTransformSeparator.

void SoGroup::addChild | ( | SoNode * | node | ) |
| virtual

Append a child node to the list of children nodes this group node is managing.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::insertChild | ( | SoNode * | child,
|  | int | newchildindex
| ) |  |
| virtual

Insert a child node at position newchildindex.

newchildindex must be <= this->getNumChildren()

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

SoNode * SoGroup::getChild | ( | int | index | ) | const
| virtual

Returns pointer to child node at index.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

int SoGroup::findChild | ( | const SoNode * | node | ) | const
| virtual

Returns index in our list of children for child node, or -1 if node is not a child of this group node.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

int SoGroup::getNumChildren | ( | void |  | ) | const
| virtual

Returns number of child nodes managed by this group.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::removeChild | ( | int | childindex | ) |
| virtual

Remove node at childindex in our list of children.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::removeChild | ( | SoNode * | child | ) |
| virtual

Remove child from the set of children managed by this group node. Will decrease the reference count of child by 1.

This is a convenience method. It will simply call findChild() with child as argument, and then call removeChild(int) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::removeAllChildren | ( | void |  | ) |
| virtual

Do not manage the children anymore. Will dereference all children by 1 as they are removed.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::replaceChild | ( | int | index,
|  | SoNode * | newchild
| ) |  |
| virtual

Replace child at index with newChild.

Dereferences the child previously at index, and increases the reference count of newChild by 1.

index must be < this->getNumChildren()

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::replaceChild | ( | SoNode * | oldchild,
|  | SoNode * | newchild
| ) |  |
| virtual

Replace oldchild with newchild.

Dereferences oldchild by 1, and increases the reference count of newchild by 1.

This is a convenience method. It will simply call findChild() with oldchild as argument, and call replaceChild(int, SoNode*) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

void SoGroup::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLTransform, SoVRMLLOD, SoVRMLGroup, SoVRMLParent, SoArray, SoSeparator, SoSwitch, SoVRMLBillboard, SoLOD, SoLevelOfDetail, SoMultipleCopy, SoPathSwitch, and SoTransformSeparator.

void SoGroup::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, SoVRMLGroup, SoArray, SoSeparator, SoSwitch, SoVRMLBillboard, SoLOD, SoVRMLCollision, SoLevelOfDetail, SoMultipleCopy, SoPathSwitch, SoTransformSeparator, and SoAnnotation.

void SoGroup::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLTransform, SoVRMLLOD, SoVRMLGroup, SoSeparator, SoArray, SoSwitch, SoPathSwitch, SoVRMLBillboard, SoGeoSeparator, SoLOD, SoLevelOfDetail, SoMultipleCopy, and SoTransformSeparator.

void SoGroup::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, SoVRMLTransform, SoVRMLGroup, SoArray, SoSeparator, SoLOD, SoSwitch, SoGeoSeparator, SoVRMLBillboard, SoLevelOfDetail, SoMultipleCopy, SoPathSwitch, SoBlinker, and SoTransformSeparator.

void SoGroup::getMatrix | ( | SoGetMatrixAction * | action | ) |
| virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLTransform, SoVRMLGroup, SoArray, SoSeparator, SoSwitch, SoGeoSeparator, SoVRMLBillboard, SoMultipleCopy, SoPathSwitch, and SoTransformSeparator.

void SoGroup::handleEvent | ( | SoHandleEventAction * | action | ) |
| virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also overrides this method.

Reimplemented from SoNode.

Reimplemented in SoExtSelection, SoSelection, SoVRMLSwitch, SoSeparator, SoArray, SoWWWAnchor, SoVRMLAnchor, SoLocateHighlight, SoSwitch, SoMultipleCopy, and SoPathSwitch.

void SoGroup::pick | ( | SoPickAction * | action | ) |
| virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoArray, SoSwitch, SoVRMLBillboard, SoMultipleCopy, SoPathSwitch, and SoTransformSeparator.

void SoGroup::search | ( | SoSearchAction * | action | ) |
| virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
  SoSearchAction

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLGroup, SoVRMLLOD, SoSeparator, SoArray, SoVRMLParent, SoSwitch, SoVRMLBillboard, SoMultipleCopy, and SoPathSwitch.

void SoGroup::write | ( | SoWriteAction * | action | ) |
| virtual

Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLGroup, SoVRMLLOD, SoVRMLParent, SoSwitch, and SoBlinker.

void SoGroup::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoVRMLGroup, SoVRMLLOD, SoVRMLTransform, SoSeparator, SoArray, SoVRMLParent, SoSwitch, SoLOD, SoGeoSeparator, SoMultipleCopy, SoPathSwitch, and SoTransformSeparator.

void SoGroup::audioRender | ( | SoAudioRenderAction * | action | ) |
| virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLGroup, SoVRMLLOD, SoVRMLTransform, SoSeparator, SoArray, SoSwitch, SoLOD, SoMultipleCopy, SoPathSwitch, SoLevelOfDetail, and SoTransformSeparator.

SoChildList * SoGroup::getChildren | ( | void |  | ) | const
| virtual

Returns list of children.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

SbBool SoGroup::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, SoSeparator, and SoVRMLParent.

SbBool SoGroup::readChildren | ( | SoInput * | in | ) |
| protectedvirtual

Read all children of this node from in and attach them below this group in left-to-right order. Returns `FALSE` upon read error.

void SoGroup::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |
| protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoNode.

Reimplemented in SoVRMLSwitch, SoVRMLLOD, and SoVRMLParent.

## Member Data Documentation

SoChildList * SoGroup::children
| protected

List of managed child nodes.

The documentation for this class was generated from the following files:

- SoGroup.h
- SoGroup.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.